#---------------------------------------------------------------
# Project         : LADS
# Module          : lads
# File            : ladsconfig.py
# Version         : $Id: ladsconfig.py,v 1.3 2005/01/02 22:27:26 fred Exp $
# Author          : Frederic Lepied
# Created On      : Mon Feb  3 19:38:22 2003
#---------------------------------------------------------------

import re
import os
import stat

from ladslog import *

exceptions = {}
exceptions_time_stamp = None

def add_exception(name, exception):
    try:
        exceptions[name].append(exception)
    except KeyError:
        exceptions[name] = [exception, ]

def get_exception(name):
    try:
        return exceptions[name]
    except KeyError:
        return ()

config = {}

def set_config(name, value):
    config[name] = value

def get_config(name, default=None):
    try:
        return config[name]
    except KeyError:
        return default
    
def load_exceptions(name):
    import ladsconfig
    
    global exceptions_time_stamp
    global exceptions
    
    exceptions = {}
    exceptions_time_stamp = os.stat(os.path.expanduser(name))[stat.ST_MTIME]
    execfile(os.path.expanduser(name), ladsconfig.__dict__, {})

def check_exceptions(name):
    global exceptions_time_stamp

    path = os.path.expanduser(name)
    new = os.stat(path)[stat.ST_MTIME]
    
    if new > exceptions_time_stamp:
        log("Reloading config from %s" % path)
        load_exceptions(path)
        
# ladsconfig.py ends here
